/*
 *
 * This file is a part of the CaosDB Project.
 *
 * Copyright (C) 2021 Timm Fitschen <t.fitschen@indiscale.com>
 * Copyright (C) 2021 IndiScale GmbH <info@indiscale.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 */

#include "caosdb/utils.h"
#include <string>
#include <gtest/gtest-message.h>
#include <gtest/gtest-test-part.h>
#include "gtest/gtest_pred_impl.h"
#include <boost/beast/core/detail/base64.hpp>

TEST(test_utils, base64_encode) {
  auto test_plain = std::string("admin:caosdb");
  auto test_encoded = std::string("YWRtaW46Y2Fvc2Ri");
  ASSERT_EQ(12, test_plain.size());
  ASSERT_EQ(16, boost::beast::detail::base64::encoded_size(test_plain.size()));
  ASSERT_EQ(test_encoded, caosdb::utils::base64_encode(test_plain));
}
